export interface LabelDefinition {
    /** A constant label value displayed for every object for which this label definition applies. */
    constant?: string;
    /** The property name that is used to get a variable part of an object's label. */
    property?: string;
}
/**
 * Resolves the given local data path against the root data.
 *
 * @param rootData the root data to resolve the data from
 * @param path The path to resolve against the root data
 * @return the resolved data or {null} if the path is not a valid path in the root data
 */
export declare const resolveLocalData: (rootData: Object, path: string) => Object;
/**
 * Extract the array index from the given path.
 */
export declare const indexFromPath: (path: string) => number;
/**
 * Gets the parent path from the given path by cutting of the last segment
 *
 * @param path The path to get the parent path from
 */
export declare const parentPath: (path: string) => string;
