/// <reference types="react" />
import { JsonSchema, UISchemaElement } from '@jsonforms/core';
import { WithImageProvider, WithLabelProvider } from './TreeWithDetailRenderer';
interface ExpandRootArrayProps {
    rootData: any;
    selection: any;
    path: string;
    handlers: any;
    filterPredicate: any;
    schema: JsonSchema | JsonSchema[];
}
/**
 * Expands the given root data array by expanding every element.
 * If the parent data containing the array is provided,
 * a suitable delete function for the expanded elements is created.
 *
 * As a difference to the ExpandArray component this component does not use containment
 * properties because it is only used for the root nodes of a tree.
 *
 */
export declare const ExpandRootArray: ({ rootData, schema, path, selection, handlers, filterPredicate, labelProvider, imageProvider }: ExpandRootArrayProps & WithLabelProvider & WithImageProvider) => any;
export interface ExpandRootArrayContainerProps extends ExpandRootArrayProps {
    uischema: UISchemaElement;
}
export declare const ExpandRootArrayContainer: ({ path, schema, rootData, selection, handlers, filterPredicate, labelProvider, imageProvider }: ExpandRootArrayContainerProps & WithLabelProvider & WithImageProvider) => JSX.Element;
export {};
