"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// tslint:disable:jsx-no-multiline-js
// tslint:disable:max-line-length
var has_1 = __importDefault(require("lodash/has"));
var get_1 = __importDefault(require("lodash/get"));
var react_1 = __importDefault(require("react"));
var core_1 = require("@jsonforms/core");
var react_2 = require("@jsonforms/react");
/* tslint:disable:next-line */
var HTML5Backend = require('react-dnd-html5-backend');
var DragDropContext = require('react-dnd').DragDropContext;
var react_redux_1 = require("react-redux");
var recompose_1 = require("recompose");
var ObjectListItem_1 = __importDefault(require("./ObjectListItem"));
var ExpandRootArray_1 = require("./ExpandRootArray");
var AddItemDialog_1 = __importDefault(require("./AddItemDialog"));
var styles_1 = require("@material-ui/core/styles");
var lodash_1 = require("lodash");
var Master = function (_a) {
    var schema = _a.schema, path = _a.path, selection = _a.selection, handlers = _a.handlers, uischema = _a.uischema, rootData = _a.rootData, filterPredicate = _a.filterPredicate, labelProviders = _a.labelProviders, imageProvider = _a.imageProvider;
    if (schema.items !== undefined) {
        return (react_1.default.createElement("ul", null,
            react_1.default.createElement(ExpandRootArray_1.ExpandRootArray, { rootData: rootData, schema: schema.items, path: path, selection: selection, handlers: handlers, filterPredicate: filterPredicate, labelProvider: labelProviders.forData, imageProvider: imageProvider })));
    }
    return (react_1.default.createElement("ul", null,
        react_1.default.createElement(ObjectListItem_1.default, { path: path, schema: schema, uischema: uischema, selection: selection, handlers: handlers, isRoot: true, filterPredicate: filterPredicate, labelProvider: labelProviders.forData, imageProvider: imageProvider })));
};
var isNotTuple = function (schema) { return !Array.isArray(schema.items); };
var styles = function () { return ({
    treeMasterDetailContent: {
        paddingTop: '1em',
        paddingBottom: '1em'
    },
    // tslint:disable-next-line: object-literal-key-quotes
    treeMasterDetail: {
        display: 'flex',
        flexDirection: 'column',
        // tslint:disable-next-line:object-literal-key-quotes
        '& $treeMasterDetailContent': {
            display: 'flex',
            flexDirection: 'row'
        }
    },
    // tslint:disable-next-line: object-literal-key-quotes
    treeMasterDetailMaster: {
        flex: 1,
        padding: '0.5em',
        height: 'auto',
        borderRight: '0.2em solid lightgrey',
        borderWidth: 'thin',
        // tslint:disable-next-line:object-literal-key-quotes
        '& ul': {
            listStyleType: 'none',
            margin: 0,
            padding: 0,
            position: 'relative',
            overflow: 'hidden',
            // tslint:disable-next-line:object-literal-key-quotes
            '&:after': {
                content: '""',
                position: 'absolute',
                left: '0.2em',
                height: '0.6em',
                bottom: '0'
            },
            '&:last-child::after': {
                display: 'none'
            }
        }
    },
    // tslint:disable-next-line: object-literal-key-quotes
    treeMasterDetailDetail: {
        flex: 3,
        padding: '0.5em',
        paddingLeft: '1em',
        // tslint:disable-next-line:object-literal-key-quotes
        '&:first-child': {
            marginRight: '0.25em'
        }
    }
}); };
var TreeWithDetailRenderer = /** @class */ (function (_super) {
    __extends(TreeWithDetailRenderer, _super);
    function TreeWithDetailRenderer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.setSelection = function (schema, data, path) { return function () {
            _this.setState({
                selected: {
                    schema: schema,
                    data: data,
                    path: path
                }
            });
        }; };
        _this.openDialog = function (schema, path) { return function () {
            _this.setState({
                dialog: {
                    open: true,
                    schema: schema,
                    path: path
                }
            });
        }; };
        _this.closeDialog = function () {
            _this.setState({
                dialog: {
                    open: false,
                    schema: undefined,
                    path: undefined
                }
            });
        };
        return _this;
    }
    TreeWithDetailRenderer.prototype.componentWillMount = function () {
        var _a = this.props, uischema = _a.uischema, data = _a.data, schema = _a.schema;
        var controlElement = uischema;
        this.setState({
            dialog: {
                open: false,
                schema: undefined,
                path: undefined
            }
        });
        var path = core_1.Paths.fromScopable(controlElement);
        if (Array.isArray(data)) {
            this.setState({
                selected: {
                    schema: schema.items,
                    data: data[0],
                    path: core_1.Paths.compose(path, '0')
                }
            });
        }
        else {
            this.setState({
                selected: {
                    schema: schema,
                    data: data,
                    path: path
                }
            });
        }
    };
    TreeWithDetailRenderer.prototype.render = function () {
        var _a = this.props, uischema = _a.uischema, schema = _a.schema, visible = _a.visible, path = _a.path, data = _a.data, rootData = _a.rootData, addToRoot = _a.addToRoot, filterPredicate = _a.filterPredicate, labelProviders = _a.labelProviders, imageProvider = _a.imageProvider, classes = _a.classes;
        var controlElement = uischema;
        var dialogProps = {
            open: this.state.dialog.open
        };
        var resetSelection;
        if (schema.items !== undefined) {
            resetSelection = this.setSelection(schema.items, data[0], core_1.Paths.compose(path, '0'));
        }
        else {
            resetSelection = this.setSelection(schema, data, path);
        }
        var handlers = {
            onSelect: this.setSelection,
            onAdd: this.openDialog,
            resetSelection: resetSelection
        };
        var detailUiSchema = this.props.findUISchema(this.state.selected.schema, undefined, path);
        return (react_1.default.createElement("div", { hidden: !visible, className: classes.treeMasterDetail },
            react_1.default.createElement("div", null,
                react_1.default.createElement("label", null, typeof controlElement.label === 'string' ? controlElement.label : ''),
                Array.isArray(data) &&
                    react_1.default.createElement("button", { onClick: addToRoot(schema, path) }, "Add to root")),
            react_1.default.createElement("div", { className: classes.treeMasterDetailContent },
                react_1.default.createElement("div", { className: classes.treeMasterDetailMaster },
                    react_1.default.createElement(Master, { uischema: uischema, schema: schema, path: path, handlers: handlers, selection: this.state.selected.data, rootData: rootData, filterPredicate: filterPredicate, labelProviders: labelProviders, imageProvider: imageProvider })),
                react_1.default.createElement("div", { className: classes.treeMasterDetailDetail }, this.state.selected ?
                    react_1.default.createElement(react_2.ResolvedJsonForms, { schema: this.state.selected.schema, path: this.state.selected.path, uischema: detailUiSchema }) : 'Select an item')),
            react_1.default.createElement("div", null, this.state.dialog.open &&
                react_1.default.createElement(AddItemDialog_1.default, { path: this.state.dialog.path, schema: this.state.dialog.schema, closeDialog: this.closeDialog, dialogProps: dialogProps, setSelection: this.setSelection, labelProvider: labelProviders.forSchema, imageProvider: imageProvider }))));
    };
    return TreeWithDetailRenderer;
}(react_1.default.Component));
exports.TreeWithDetailRenderer = TreeWithDetailRenderer;
var mapStateToProps = function (state, ownProps) {
    var rootData = core_1.getData(state);
    var path = core_1.Paths.compose(ownProps.path, core_1.Paths.fromScopable(ownProps.uischema));
    var visible = has_1.default(ownProps, 'visible') ? ownProps.visible : core_1.Runtime.isVisible(ownProps.uischema, rootData);
    var enabled = has_1.default(ownProps, 'enabled') ? ownProps.enabled : core_1.Runtime.isEnabled(ownProps.uischema, rootData);
    var rootSchema = core_1.getSchema(state);
    var resolvedSchema = core_1.Resolve.schema(ownProps.schema, ownProps.uischema.scope, rootSchema);
    return {
        rootData: core_1.getData(state),
        label: get_1.default(ownProps.uischema, 'label'),
        data: core_1.Resolve.data(rootData, path),
        uischema: ownProps.uischema,
        schema: resolvedSchema || rootSchema,
        findUISchema: core_1.findUISchema(state),
        path: path,
        visible: visible,
        enabled: enabled,
        filterPredicate: ownProps.filterPredicate,
        imageProvider: ownProps.imageProvider,
        labelProviders: ownProps.labelProviders,
        rootSchema: core_1.getSchema(state),
        id: core_1.createId('tree'),
        errors: lodash_1.union(core_1.getErrorAt(path)(state).map(function (error) { return error.message; }))
    };
};
var mapDispatchToProps = function (dispatch) { return ({
    addToRoot: function (schema, path) {
        return function () {
            if (isNotTuple(schema)) {
                dispatch(core_1.Actions.update(path, function (data) {
                    var clonedData = data.slice();
                    clonedData.push({});
                    return clonedData;
                }));
            }
        };
    }
}); };
var DnDTreeMasterDetail = recompose_1.compose(styles_1.withStyles(styles, { name: 'TreeMasterDetail' }), DragDropContext(HTML5Backend))(TreeWithDetailRenderer);
var ConnectedTreeWithDetailRenderer = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(DnDTreeMasterDetail);
exports.default = ConnectedTreeWithDetailRenderer;
//# sourceMappingURL=TreeWithDetailRenderer.js.map